# coding: utf-8
"""
    Enum for asset discovery type.
"""

import pprint


class DiscoveryType:
    """
    Enum for asset discovery type.
    """

    """
    allowed enum values
    """
    AUTOMATIC = "AUTOMATIC"
    MANUAL = "MANUAL"

    """
    Attributes:
      property_types (dict): The key is attribute name
                            and the value is attribute type.
      serialization_keys (dict): The key is attribute name
                            and the value is json key in definition.
    """
    property_types = {
    }

    serialization_keys = {
    }

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.property_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DiscoveryType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self.__eq__(other)
