from abc import ABC, abstractmethod

from asset_discovery.models import Asset, OperationResult


class AddRequestBuilderBase(ABC):

    @abstractmethod
    def build_from(self, asset: Asset, **kwargs) -> OperationResult:
        pass

    def _get_first_ip_address(self, asset: Asset):
        ip_addresses = asset.ip_addresses
        if ip_addresses is not None and len(ip_addresses) > 0:
            ip_address = ip_addresses[0]
            if ip_address is not None:
                return ip_address
        return None
